/*--------------------------------------------------------------------.
| qfm.c							              |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/

static char rcsid[] = "$Id$";

/*
 * $Log$
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include "qfm.h"

#define MXX(p) sizeof(p), p

char _prog_name[] = "qfm" " v" VERSION;
void (*_SigStart)(void) = NULL;

typedef struct
{
    int act;
    char *title;
    short skey;
} MACT;

unsigned char colarray[12] = {4, 7, 2, 4, 255, 0, 7, 4, 7, 0, 2, 0};

static MACT mact[] =
{
    {EXEC, "Edit Fax", -1},
    {EXEC, "Make Fax", -1}, 
    {EXEC, "View Fax", -1},
    {EXEC, "Send Fax", -1},
    {EXEC, "Print Fax", -1},    
    {EXEC, "Receive Fax", -1},    
    {SEP,  "Utilities"},
    {EXEC, "Edit $QFAX_DATA",-6},
    {EXEC, "Edit Phone Book", -12},
    {EXEC, "View Log", -6},
    {EXEC, "View Info", -6},
    {0,    "Exit", -2}
};

#define NMACT (sizeof(mact)/sizeof(MACT))
 
void *xalloc (int i)
{
    void *p;
    if ((p = malloc (i)))
    {
	memset (p, '\0', i);
    }
    else
	exit (-3);
    return p;
}

void xfree (void *q)
{
    if (q)
	free (q);
}

char *strdup (char *p)
{
    char *q;
    q = xalloc (strlen (p) + 1);
    strcpy (q, p);
    return q;
}


long _stack = 12000;

int main(int ac, char **av)
{
    short i;
    ITEMS *it,*xt;
    MINFO *mi;
    MENUS *mmm;

    it = xalloc(NMACT*sizeof(ITEMS));

    mmm = xalloc(sizeof(MENUS)); 
    mmm->title = "Fax Utility";
    mmm->width = 0;
    mmm->height = NMACT;
    mmm->items = it;

    for(xt = it, i = 0; i < NMACT;)
    {
	short n;

	n = (mact[i].title) ?  strlen(mact[i].title) : 0;
	if(n > mmm->width) mmm->width = n;
	mi = xalloc(sizeof(MINFO)+ n + 4); /* FIXME */
	xt->l = mi;
	mi->act = mact[i].act;
	mi->len = (mi->act != SEP) ? n : 0;
	mi->skey = mact[i].skey;
	strcpy(mi->chrs, mact[i].title);

	i++;
	if(i == NMACT)
	{
	    xt->next = NULL;
	}
	else
	{
	    xt->next = xt+1;
	    xt++;
	}
    }
    mmm->width += 6;
    {

	int chid = io_open("con", 0);
	extern int menu(int, MENUS *);

	if(chid <= 0)
	{
	    return -1;
	}
	
	if (!(wm_findv (chid)))
	{
	    return -1;
	}
	menu(chid, mmm);
    }
    return 0;
}
int (*_Cstart) () = main;
