/*--------------------------------------------------------------------.
| qfm.h							              |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/

/*
 * $Log$
 */

#define EXEC  1
#define SEP   2

#include "version.h"

/*---------------------------------.
| Structure to hold menu item info |
`---------------------------------*/

typedef struct
{
    short skey;
    short act;
    short len;
    char chrs[1];		/* Will be allocated size as required */
} MINFO;

/*-------------------------------.
| Define structure for menu item |
`-------------------------------*/

typedef struct _items ITEMS;

struct _items
{
    ITEMS *next;
    MINFO *l;
};

/*--------------------------------------------------------------.
| Define structure for a  menu (as parsed, not what QPTR needs) |
`--------------------------------------------------------------*/

typedef struct
{
    char *title;
    short width;
    short height;
    ITEMS *items;
} MENUS;


#define COLBORD  0
#define COLPAPR  1
#define COLPSAC  2
#define COLPSBC  3
#define COLPSCC  4
#define COLCURC  5
#define COLUBACK 6
#define COLUINK  7
#define COLABACK 8
#define COLAINK  9
#define COLSBACK 10
#define COLSINK  11
#define MAXCOL   12

extern unsigned char colarray[13];

extern void *xalloc (int);
extern void xfree (void *);

typedef struct _list
{
    void *next;
    char item[1];
} LIST;

typedef struct
{
    LIST *list;
    char in_dir[64];
    char info_file[64];
    char Temp[32];
    char suffix[16];
    char  phonebook[40];
    char *lmb[12];
    char *rmb[12];
} FAXDATA;


extern ListBook(char *p, FAXDATA *ff);
extern void FaxParams(FAXDATA **);
extern void FreeParams(FAXDATA **);
