/*--------------------------------------------------------------------.
| qless.c							      |
| 								      |
| Copyright (c) 1997 Jonathan Hudson				      |
| 								      |
| You may distribute under the terms of either the GNU General Public |
| License or the Artistic License, as specified in the README file.   |
`--------------------------------------------------------------------*/
static char rcsid[] = "$Id$";
/*
 * $Log$: 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <time.h>
#include <things.h>
#include <qptr.h>

void (*_SigStart)(void) = NULL;

typedef struct mitem
{
    short len;
    char chrs[1];
} MITEM;

typedef struct
{
    void *next;
    void *item;
} LLIST;

typedef struct
{
    struct QD_text *qtext;
    unsigned char status;
} MDEF;

char _prog_name[] = "qless";

typedef struct WM_menw WM_menw_t;

static long MACT (WM_wwork_t *wwk, WM_menw_t *mw, char *mst, 
		  short col, short row);
static long MDRAW (WM_wwork_t *wwk, struct WM_menw *mw);

static struct WM_action mdraw = {JSR, wm_drwaw, MDRAW};
static struct WM_action mact = {JSR, wm_actme, MACT};

#define MAX_SECT    1

#define ninfw   3
#define ninfo   1
#define nlitm   1
#define nappl   1

static WM_PWCB (2) pwcy = {0};
static QD_TEXTI (PROMPT, "         ");
static long MESC (WM_wwork_t *wwk, struct WM_litm *li);
static struct WM_action mesc = {JSR, wm_actli, MESC};
static QD_TEXTI (ESCAPE, "Quit");

static struct WM_info info[] =	/* information objects */
{
    {60, 10,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {0, 0, 0}, 		/* ink, cwid, chgt      character attributes */
     &PROMPT},			/* *pobj                pointer to object */
    {-1}
};

static struct WM_infw infw[] =
{
    {0, 14,		/* xsize, ysize         size */
     0, 0,		/* xorg, yorg           and origin */
     0,			/* flag                 no clear + shadow */
     0, 0, 127,		/* borw, borc, papr     border width/clr, paper */
     NULL},		/* *pobj                pointer to object list */
    {66, 10,		/* xsize, ysize         size */
     4, 2,		/* xorg, yorg           and origin */
     0,			/* flag                 no clear + shadow */
     1, 255, 7,         /* borw, borc, papr     border width/clr, paper */
     info},		/* *pobj                pointer to object list */
    {24, 10,		/* xsize, ysize         size */
     200, 2,		/* xorg, yorg           and origin */
     0,
     1,255,7, NULL},
    {-1}
};

static struct WM_menw mw =	/* menu window */
{
    0, 0,		/* xsize, ysize         size */
    2, 14,		/* xorg, yorg           and origin */
    0,  		/* flag                 no clear + shadow */
    1, 0, 7,		/* borw, borc, papr     border width/clr, paper */
    NULL,		/* *pspr                pointer to sprite */
    &mdraw,		/* *draw                draw routine */
    wm__mhit,		/* *hit                 hit routine */
    wm__pnsc,		/* *ctrl                control routine */
    0, MAX_SECT,	/* nxsc, nysc           max x,y sections */
    0, 0, 0,		/* skey, 2 spare        selection keystroke */
    NULL,		/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 7, 0,	  /* psac, psbc, pssc arrow/bar clrs */
    (WM_pwcb_t *) &pwcy,	/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    2, 7, 0,          	/* psac, psbc, pssc arrow/bar clrs */
    NULL,		/* *mstt                menu status area */
    1, 0,		/* curw, curc           current item width/clr */
    7, 0, NULL, NULL,	/* uback, uink, *ublob, *upatt unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    0, 7, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
    1, 0,			/* ncol, nrow           columns and rows */
    0, 0,			/* xoff, yoff           window offset */
    {0, 0},			/* -xsize, -xspce     or *xspc spacing list */
    {-10, -12},			/* -ysize, -yspce     or *yspc spacing list */
    NULL, NULL,			/* *xind, *yind         not implemented */
    NULL			/* *rowl                row list */
};

static struct WM_litm plitm[] =	/* loose item */
{
    {24, 10,			/* xsize, ysize         size */
     200, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 3,		/* type, skey           type and select key */
     &ESCAPE,			/* *pobj                pointer to object */
     0,				/* item                 item number */
     &mesc},			/* *pact                pointer to action */
    {-1}
};

struct WM_appl appl[] = {(WM_appw_t *) &mw, NULL};

static WM_wwork_t ww =	/* window working definition */
{
    NULL,	/* *wstat;              pointer to status area */
    NULL,	/* *wscale              this was pointer to WDEF */
    0,		/* chid                 channel ID */
    NULL,	/* *pprec               pointer to pointer record */
    0,		/* psave                pointer position saved */
    0, 0, 0, 0,	/* 4 zero */
    appl,	/* *splst               pointer to sprite list */
    0, 0,	/* xsize, ysize will need changing */
    4, 23,	/* xorg, yorg           and origin */
    2 | NO_WCLEAR,	/* flag                 no clear + shadow */
    1, 0, 255,    	/* borw, borc, papr     border width/clr, paper */
    NULL,		/* *sprite              pointer to sprite */
    1, 0,		/* curw, curc           current item width/clr */
    7, 0, NULL, NULL,	/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,	/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, plitm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};
    
static struct WM_wstat ws = {0};

#define MAXX 480
#define MAXY 240

void menu_chks (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;
    short spacing;

    pwcb = menu->ypwcb;		/* part window control block (scroll) */
    spacing = -menu->ys.c._spce;

    if (menu->nrow > menu->ysize / spacing)
    {
	if (pwcb->nsec == 0)
	    menu->xsize -= WW_XBAR;	/* adjust width for bar */
	pwcb->nsec = 1;		/* one section */
	pwcb->s[0].stt = 0;	/* from zero */
	pwcb->s[0].siz = ((menu->ysize - WW_YARROW * 2) / spacing); /* size */
	menu->yoff = WW_YARROW;	/* offset for arrows */
    }
    else
    {
	if (pwcb->nsec)
	    menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
	menu->yoff = 0;		/* no arrows, no offset */
    }
    menu->xs.c._spce = -(menu->xsize) / menu->ncol;
    menu->xs.c._size = menu->xs.c._spce + menu->curw * 4;
}

/*******************************************************************************
*
*   Given a pointer to a menu sub-window working definition for a scrollable
*   menu this function removes the scroll bar and arrows (if present)
*
*******************************************************************************/

void menu_rems (struct WM_menw *menu)
{
    struct WM_pwcb *pwcb;

    pwcb = menu->ypwcb;		/* part window control block (scroll) */

    if (pwcb->nsec)
    {
	menu->xsize += WW_XBAR;	/* adjust width for no bar */
	pwcb->nsec = 0;		/* no sections */
	menu->yoff = 0;
    }				/* no arrows, no offset */
}


void LoadMenu (struct WM_menw *menu, LLIST *list)
{
    int i;
    struct WM_rowl *rowl;
    struct WM_mobj *mobj;
    char *mstt;
    LLIST *p;
    int nitem;

    for (p = list, nitem = 0; p; p = p->next, nitem++)
    	; /* NULL LOOP to find nitems */

    if (menu->rowl)
    {
	free (menu->rowl);
    }

    menu->rowl = NULL;
    menu->ncol = 1;
    menu->nrow = nitem;

    menu->rowl =
	rowl = (struct WM_rowl *)
	malloc((int) ((sizeof (struct WM_rowl) + sizeof (struct WM_mobj) + 1) * nitem));

    mobj = (struct WM_mobj *)
	(((char *) rowl) + sizeof (struct WM_rowl) * nitem);

    menu->mstt =
	mstt = ((char *) mobj) + sizeof (struct WM_mobj) * nitem;

    for (i = 0; i < nitem; i++)	/* initialise menu structures */
    {
	mobj->xjst = 1;
	mobj->yjst = 0;
	mobj->type = 0;
	mobj->skey = 0;
	mobj->pobj = (char *) ((MDEF *) list->item)->qtext;
	mobj->item = i;
	mobj->pact = &mact;
	rowl->rows = mobj++;	/* one object per row */
	(rowl++)->rowe = mobj;
	*(mstt++) = ((MDEF *) list->item)->status;
	list = list->next;	/* next text */
    }
}


static long lit_reset (WM_wwork_t *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;	/* set make available */
    return wm_ldraw (wwk, -1);	/* and re-draw */

}

int menu (LLIST *MList, short icount, short flag, short nx)
{
    int rval;
    short flg = 0;
    int xsize = 0, ysize = 0;
    short yinc;
    struct WM_wsiz wl;

    ww.chid = io_open("con", 0);

    if(ww.chid < 0)
    {
        return -1;
    }

    if (!(wm_findv (ww.chid)))
    {
        return -1;
    }

    iop_flim(ww.chid, -1, &wl);

    ws.wmode = FORM_QL4;
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;

    yinc = 12;
    ysize =  icount * yinc;

    if(ysize > wl.ysize-20)
    {
        ysize = yinc*((wl.ysize - 28)/yinc) ;
        flg = 1;
    }
    if(nx < 20) nx = 20;

    xsize = nx*6+18;
    if(xsize > wl.xsize-8)
	xsize = wl.xsize - 20;
    
    LoadMenu (&mw, MList);

    infw[0].xsize = xsize;
    ww.xsize = xsize;
    mw.xsize = xsize - 4;

    mw.ysize = ysize;

    ww.ysize = 16 + mw.ysize;
    mw.xs.c._size = -mw.xsize + 4;
    mw.xs.c._spce = -mw.xsize;

    mw.ys.c._spce = -yinc;

    ws.citem = -1;		/* no current item  */
    infw[2].xorg = plitm[0].xorg = xsize - plitm[0].xsize - 6;

    mw.curc = (flag) ? 2 : 7;
    mw.borc = 255;        
    infw[0].papr = 84;

    memcpy(PROMPT.chrs+1, ((flag) ? "Chooser" : "Viewer "), 7);

    wm_prpos (&ww, -1, -1);	/* pull down */
    wm_wdraw (&ww);

    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
#if 0
	if(ws.evnt & PT_WMOVE)
	{
	    menu_rems(&mw);
            LoadMenu (&mw, MList);
	    wm_swapp(&ww, 0, -1);
    	    sd_clear(ww.chid, -1);
	    MDRAW(&ww, &mw);
	}
#endif
    }
    return ws.litem[39];
}

static long MDRAW (WM_wwork_t *wwk, struct WM_menw *mw)
{
    menu_chks (mw);
    wm_index (wwk, (struct WM_swdef *) mw);
    wm_mdraw (wwk, (struct WM_swdef *) mw, 0);
}

static long MACT (WM_wwork_t *wwk, WM_menw_t *mw, char *mst, 
		  short col, short row)
{
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;	/* current menu object */
    wwk->wstat->litem[39] = mobj->item;
    return PT__CAN;
}
static long MESC (WM_wwork_t *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[39] = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}


#if 0
#include <stdio.h>
#include <stdarg.h>
void Report (char *ctl,...)
{
    va_list va;
    char t[80];

    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    io_sstrg (0x00010001, -1, t, strlen (t));
}
#endif


LLIST * BuildMenu (int *ni, char *fn, short flag, short *nx)
{
    int n = -1;
    char txt[256];
    int fd,nc;
    short ll;
    MITEM *s;
    MDEF *pm;
    LLIST *pl, *pz, *ph = NULL;

    if((fd = io_open(fn,  OLD_SHARE)) > 0)
    {
	n = 0;
	while((nc = io_fline(fd, -1, txt, sizeof(txt))) > 0)
	{
	    char *l;
	    if((l = strchr(txt, '\n'))) *l = 0;
	    nc = strlen(txt) + 4;
	    s = (MITEM *) malloc (nc);
	    strcpy (s->chrs, txt);
	    s->len = strlen (s->chrs);
	    if(s->len > *nx) *nx = s->len;
	    pm = (MDEF *) malloc (sizeof (MDEF));
	    pm->qtext = (struct QD_text *) s;
	    pm->status = (flag) ? WSI_AVBL: WSI_UNAV;

	    pl = (LLIST *) malloc (sizeof (LLIST));
	    pl->item = pm;
	    pl->next = NULL;
	    if(ph == NULL) ph = pl;
	    if(pz)
	    {
		pz->next = pl;
	    }
	    pz = pl;
	    if(ll > *nx) *nx = ll;
	    n++;
	}
	io_close(fd);
    }
    *ni = n;
    return ph;
}

int main(int ac, char **av)
{
    int opt;
    LLIST *RFxList = NULL;
    int RFxNum;
    int n;
    short nx, nc;
    char *sp;
    
    sp = *(av + 1);
    nc = *((short *) (sp));
    sp += sizeof(short) + nc * sizeof(long);
    nc = *((short *) (sp));

    if(nc > 0)
    {
	char *f, fn[40];
	char flag;
	short nm;
	sp += sizeof(short);
	if(f = memchr(sp, ' ', nc))
	{
	    nm = f-sp;
	}
	else nm = nc;

	strncpy(fn, sp, nm);
	*(fn+nm) = 0;
	flag = (nm < nc); 
	nx = 0;	
	if((RFxList = BuildMenu(&RFxNum, fn, flag, &nx)))
	{
	    n = menu(RFxList, RFxNum, flag, nx);
	    if(n >= 0)
	    {
		short i;
		LLIST *p;
		for (p = RFxList, i = 0; i < n; p = p->next,i++)
		    ;
		
		{
		    MITEM *s;
		    MDEF *pm;
		    pm = (MDEF *) p->item;
		    s = (MITEM *) pm->qtext;
		    hk_stbuf(s->chrs);
		    n = 0;
		}
	    }
 	}
    }
    return n;
}
int (*_Cstart) () = main;

